using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Accessing_image_data
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label lblCoords;
		private System.Windows.Forms.TextBox txtImageData;
		private TIS.Imaging.ICImagingControl icImagingControl1;
        private TIS.Imaging.FrameSnapSink _fhs;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.lblCoords = new System.Windows.Forms.Label();
            this.txtImageData = new System.Windows.Forms.TextBox();
            this.icImagingControl1 = new TIS.Imaging.ICImagingControl();
            ((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(13, 388);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(128, 22);
            this.label1.TabIndex = 1;
            this.label1.Text = "Image data @";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(13, 11);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(458, 30);
            this.label2.TabIndex = 2;
            this.label2.Text = "Move the mouse over the live video to select a pixel";
            // 
            // lblCoords
            // 
            this.lblCoords.Location = new System.Drawing.Point(141, 388);
            this.lblCoords.Name = "lblCoords";
            this.lblCoords.Size = new System.Drawing.Size(77, 22);
            this.lblCoords.TabIndex = 3;
            this.lblCoords.Text = "N/A";
            // 
            // txtImageData
            // 
            this.txtImageData.Location = new System.Drawing.Point(230, 388);
            this.txtImageData.Multiline = true;
            this.txtImageData.Name = "txtImageData";
            this.txtImageData.Size = new System.Drawing.Size(154, 88);
            this.txtImageData.TabIndex = 4;
            this.txtImageData.Text = "N/A";
            // 
            // icImagingControl1
            // 
            this.icImagingControl1.BackColor = System.Drawing.Color.White;
            this.icImagingControl1.DeviceListChangedExecutionMode = TIS.Imaging.EventExecutionMode.Invoke;
            this.icImagingControl1.DeviceLostExecutionMode = TIS.Imaging.EventExecutionMode.AsyncInvoke;
            this.icImagingControl1.ImageAvailableExecutionMode = TIS.Imaging.EventExecutionMode.MultiThreaded;
            this.icImagingControl1.LiveDisplayPosition = new System.Drawing.Point(0, 0);
            this.icImagingControl1.Location = new System.Drawing.Point(13, 44);
            this.icImagingControl1.Name = "icImagingControl1";
            this.icImagingControl1.Size = new System.Drawing.Size(576, 333);
            this.icImagingControl1.TabIndex = 5;
            this.icImagingControl1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.icImagingControl1_MouseMove);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(8, 18);
            this.ClientSize = new System.Drawing.Size(624, 513);
            this.Controls.Add(this.icImagingControl1);
            this.Controls.Add(this.txtImageData);
            this.Controls.Add(this.lblCoords);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Name = "Form1";
            this.Text = "Accessing image data";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		
		private void Form1_Load(object sender, System.EventArgs e)
		{
			icImagingControl1.ShowDeviceSettingsDialog();

			if( !icImagingControl1.DeviceValid )
			{
				Close();
				return;
			}
             _fhs = new TIS.Imaging.FrameSnapSink(TIS.Imaging.MediaSubtypes.RGB24);
            icImagingControl1.Sink = _fhs;
			icImagingControl1.LiveStart();
		}
		private void icImagingControl1_MouseMove(object sender, MouseEventArgs e)
		{
			lblCoords.Text = e.X + "," + e.Y;
            TIS.Imaging.IFrameQueueBuffer rval =  _fhs.SnapSingle(TimeSpan.FromSeconds(1));
            BufferAccessHelper buf = new BufferAccessHelper(rval);

            int indexXred = e.X * 3 + 2;
            int indexXgreen = e.X * 3 + 1;
            int indexXblue = e.X * 3;

            int indexY = rval.FrameType.Height - e.Y- 1;

            byte red = buf[indexXred, indexY];
            byte green = buf[indexXgreen, indexY];
            byte blue = buf[indexXblue, indexY];

            if (e.X < rval.FrameType.Width && e.Y < rval.FrameType.Height)
            {
            
				txtImageData.Text = string.Format( "Red\t=  {0}\r\nGreen\t=  {1}\r\nBlue\t=  {2}", red, green, blue );
			}
			else
			{
				txtImageData.Text = "<Outside of image>";
			}
		}

        class BufferAccessHelper
        {
            TIS.Imaging.IFrameQueueBuffer buf;

            public BufferAccessHelper(TIS.Imaging.IFrameQueueBuffer buf)
            {
                this.buf = buf;
            }

            public unsafe byte this[int x, int y]
            {
                get
                {
                    byte* ptr = buf.Ptr + y * buf.FrameType.BytesPerLine + x;
                    return *ptr;
                }
                set
                {
                    byte* ptr = buf.Ptr + y * buf.FrameType.BytesPerLine + x;
                    *ptr = value;
                }
            }
        }

    }

}
